﻿Imports Inventor


Public Class Bohrungen_umfaerben
    Dim oInventorApp As Object = System.Runtime.InteropServices.Marshal.GetActiveObject("Inventor.Application")
    'Dim oInventorApp As Inventor.Application
    Dim oDoc As Inventor.PartDocument



    Public Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If oInventorApp.ActiveDocumentType <> DocumentTypeEnum.kPartDocumentObject Then
            MsgBox("Kein Bauteil")
            Exit Sub
        End If


    End Sub

    Private Sub cmb_Start_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Start.Click
        'Nachsachauen ob Inventor offen ist.

        If oInventorApp.ActiveDocumentType.ToString <> DocumentTypeEnum.kPartDocumentObject Then
            MsgBox("Kein Bauteil")
            Exit Sub
        End If


        oInventorApp = GetObject(, "Inventor.Application")
        Dim oGewindegelb As RenderStyle
        Dim oRedStyle As RenderStyle
        Dim oHRot, oNGrau As RenderStyle
        Dim oNormal As RenderStyle
        oDoc = oInventorApp.ActiveDocument
        'oNormal = oDoc.ActiveRenderStyle '.Name.ToString '.GetType '.Type.ToString '   RenderStyles.

        'MsgBox(oNormal)
        ' Prüfe ob die Farbe "Gewindegelb" vorhanden ist
        If CheckStyleByName(oDoc, "Gewindegelb") Then
            oGewindegelb = oDoc.RenderStyles("Gewindegelb")
        Else
            ' Die Farbe "Gewindegelb" einfügen
            oGewindegelb = oDoc.RenderStyles.Add("Gewindegelb")
            oGewindegelb.SetAmbientColor(255, 255, 0)
            oGewindegelb.SetDiffuseColor(255, 255, 0)
            oGewindegelb.SetEmissiveColor(255, 255, 0)
            oGewindegelb.SetSpecularColor(255, 255, 0)
        End If

        ' Prüfe ob die Farbe "HRot" vorhanden ist
        If CheckStyleByName(oDoc, "HRot") Then
            oHRot = oDoc.RenderStyles("HRot")
        Else
            ' Die Farbe "Rot" einfügen
            oHRot = oDoc.RenderStyles.Add("HRot")
            oHRot.SetAmbientColor(255, 0, 0)
            oHRot.SetDiffuseColor(255, 0, 0)
            oHRot.SetEmissiveColor(255, 0, 0)
            oHRot.SetSpecularColor(255, 0, 0)
        End If

        ' Prüfe ob die Farbe "Grün" vorhanden ist

        If CheckStyleByName(oDoc, "NGrau") Then
            oNGrau = oDoc.RenderStyles("NGrau")
        Else
            ' Die Farbe "Rot" einfügen
            oNGrau = oDoc.RenderStyles.Add("NGrau")
            oNGrau.SetAmbientColor(210, 210, 255)
            oNGrau.SetDiffuseColor(210, 210, 255)
            oNGrau.SetEmissiveColor(210, 210, 255)
            oNGrau.SetSpecularColor(210, 210, 255)
        End If

        Dim oHoleFeature As HoleFeature

        'H7 Bohrungen Einfärben

        If chb_H7_Bohrungen.Checked = True Then

            For Each oHoleFeature In oDoc.ComponentDefinition.Features.HoleFeatures
                Try


                    If oHoleFeature.HoleDiameter.Tolerance.HoleTolerance = "H7" Then
                        'H7 Bohrung
                        oHoleFeature.SetRenderStyle(StyleSourceTypeEnum.kOverrideRenderStyle, oHRot)

                    End If
                Catch ex As Exception

                End Try
            Next
        End If

        'Gewinde Bohrungen Einfärben

        If chb_Gewinde.Checked = True Then

            For Each oHoleFeature In oDoc.ComponentDefinition.Features.HoleFeatures
                If oHoleFeature.Tapped = True Then
                    'Gewinde
                    oHoleFeature.SetRenderStyle(StyleSourceTypeEnum.kOverrideRenderStyle, oGewindegelb)
                End If
            Next

        End If


    End Sub
    Private Function CheckStyleByName(ByVal Doc As Document, ByVal Name As String) As Boolean

        Dim oRender As RenderStyle
        For Each oRender In Doc.RenderStyles
            If oRender.Name = Name Then
                CheckStyleByName = True
                Exit Function
            End If
        Next

        CheckStyleByName = False

    End Function


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        chb_Gewinde.Checked = False
        chb_H7_Bohrungen.Checked = False

        If oInventorApp.ActiveDocumentType <> DocumentTypeEnum.kPartDocumentObject Then
            MsgBox("Kein Bauteil")
            Exit Sub
        End If

        'Auf Bauteilfarbe zurücksetzen
        For Each oHoleFeature In oDoc.ComponentDefinition.Features.HoleFeatures

            oHoleFeature.SetRenderStyle(StyleSourceTypeEnum.kOverrideRenderStyle, oDoc.ActiveRenderStyle)

        Next

    End Sub
End Class
